<!DOCTYPE html>
<html>

<head>
    <link rel="stylesheet" href="css/pico.min.css">
    <style>
        button {all: unset !important; cursor: pointer !important;}
    </style>
</head>

<body>

    <header class="container">
        <hgroup>
            <h1>Munta</h1>
            <p>Your locally hosted one-stop-shop for all your conversion needs.</p>
        </hgroup>
    </header>

    <form action="upload.php" method="post" enctype="multipart/form-data">
    
        <main class="container">

            <input id="picker" type="file" name="file">
            
            <article id="audfxs" style="display: none;"><details><summary>Filters</summary>
              
              <details>
                <summary>Effects</summary>
                <ul role="listbox">
                  <li>
                    <label>
                      <input type="checkbox" name="tremolo" value="tremolo">
                      Add Tremolo
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="vibrato" value="vibrato">
                      Add Vibrato
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="speechnorm" value="speechnorm">
                      Normalize Speech
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="loudnorm" value="loudnorm">
                      Normalize Loudness
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="extrastereo" value="extrastereo">
                      Boost stereo
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="asubboost" value="asubboost">
                      Boost subwoofer
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="dialoguenhance" value="dialoguenhance">
                      Enhance dialogue
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="earwax" value="earwax">
                      Enhance headhpones (Earwax)
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="bs2b" value="bs2b">
                      Enhance headhpones (Bauer)
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="flanger" value="flanger">
                      Flanging effect
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="aphaser" value="aphaser">
                      Phaser effect
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="anlmdn" value="anlmdn">
                      Denoise
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="crystalizer" value="crystalizer">
                      Sharpen Noise
                    </label>
                  </li>
                </ul>
              </details>
              
              <details class="dropdown">
                <summary>Echo</summary>
                <ul role="listbox">
                  <li>
                    <label for="echo-none">
                      <input id="echo-none" type="radio" name="echo" value="none" checked>
                      None
                    </label>
                  </li>
                  <li>
                    <label for="echo-two">
                      <input id="echo-two" type="radio" name="echo" value="two">
                      Two instruments
                    </label>
                  </li>
                  <li>
                    <label for="echo-robot">
                      <input id="echo-robot" type="radio" name="echo" value="robot">
                      Like a robot
                    </label>
                  </li>
                  <li>
                    <label for="echo-mountains">
                      <input id="echo-mountains" type="radio" name="echo" value="mountains">
                      In the mountains
                    </label>
                  </li>
                  <li>
                    <label for="echo-more">
                      <input id="echo-more" type="radio" name="echo" value="more">
                      More mountains
                    </label>
                  </li>
                </ul>
              </details>
              
            </details></article>
            
            <article id="picfxs" style="display: none;"><details><summary>Filters</summary>
            
            <details class="dropdown">
                <summary>Rotate & Flip</summary>
                <ul role="listbox">
                  <li>
                    <label for="transforms-none">
                      <input id="transforms-none" type="radio" name="transforms" value="none" checked>
                      None
                    </label>
                  </li>
                  <li>
                    <label for="transforms-hflip">
                      <input id="transforms-hflip" type="radio" name="transforms" value="hflip">
                      Flip horizontally
                    </label>
                  </li>
                  <li>
                    <label for="transforms-vflip">
                      <input id="transforms-vflip" type="radio" name="transforms" value="vflip">
                      Flip vertically
                    </label>
                  </li>
                  <li>
                    <label for="transforms-clkrot">
                      <input id="transforms-clkrot" type="radio" name="transforms" value="clkrot">
                      Rotate 90° clockwise
                    </label>
                  </li>
                  <li>
                    <label for="transforms-aclkrot">
                      <input id="transforms-aclkrot" type="radio" name="transforms" value="aclkrot">
                      Rotate 90° anticlockwise
                    </label>
                  </li>
                  <li>
                    <label for="transforms-reverse">
                      <input id="transforms-reverse" type="radio" name="transforms" value="reverse">
                      Rotate 180°
                    </label>
                  </li>
                </ul>
              </details>
            
              <details class="dropdown">
                <summary>Effects</summary>
                <ul role="listbox">
                  <li>
                    <label>
                      <input type="checkbox" name="blur" value="blur">
                      Blur
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="pixelize" value="pixelize">
                      Pixelize
                    </label>
                  </li>
                  <li>
                    <label>
                      <input type="checkbox" name="vignette" value="vignette">
                      Vignette
                    </label>
                  </li>
                </ul>
              </details>
              
              <details class="dropdown">
                <summary aria-haspopup="listbox">Colorization</summary>
                <ul role="listbox">
                  <li>
                    <label for="colorize-none">
                      <input id="colorize-none" type="radio" name="colorize" value="none" checked>
                      None
                    </label>
                  </li>
                  <li>
                    <label for="colorize-bw">
                      <input id="colorize-bw" type="radio" name="colorize" value="bw">
                      Black & White
                    </label>
                  </li>
                  <li>
                    <label for="colorize-sepia">
                      <input id="colorize-sepia" type="radio" name="colorize" value="sepia">
                      Sepia
                    </label>
                  </li>
                </ul>
              </details>
              
            </details></article>
            
            <article id="options" style="display: none;"></article>
            
        </main>

    </form>
    
    <script>
        document.getElementById('picker').addEventListener('change', function(e) {
          if (e.target.files[0]) {
            const extension = e.target.files[0].name.split('.').pop();
            let optionsPath = "";
            switch (extension) {
              case "flac":
              case "ogg":
              case "oga":
              case "mka":
              case "caf":
              case "tta":
              case "mp1":
              case "mp2":
              case "mp3":
              case "spx":
              case "wv":
              case "opus":
              case "ts":
                optionsPath = "json/audio.json";
                break;
              case "jpg":
              case "jpeg":
              case "png":
              case "qoi":
              case "exr":
              case "webp":
              case "jxl":
              case "gif":
              case "jp2":
              case "j2k":
              case "j2c":
              case "avif":
                optionsPath = "json/picture.json";
                break;
            }
            fetch(optionsPath)
              .then((response) => response.json())
              .then((json) => {
                const elOptions = document.getElementById("options");
                
                // Empty options area
            	  while (elOptions.firstChild) {
            	    elOptions.removeChild(elOptions.lastChild);
            	  }
                
                for (encoding of json) {
                  const elDetails = document.createElement("details");
                  const elSummary = document.createElement("summary");
                  const txSummary = document.createTextNode(encoding.abbr + (encoding.name ? " (" + encoding.name + ") " : " "));
                  elSummary.appendChild(txSummary);
                  elDetails.appendChild(elSummary);
                  elOptions.appendChild(elDetails);
                  
                  for (toExt of encoding.containers[0].extensions) {
                    const txSpace  = document.createTextNode(" ");
                    const elKboard = document.createElement("kbd");
                    const elButton = document.createElement("button");
                    const txButton = document.createTextNode(toExt);
                    elButton.setAttribute("value", encoding.abbr + "/" + toExt);
                    elButton.setAttribute("name", "submit");
                    elKboard.appendChild(txButton);
                    elButton.appendChild(elKboard);
                    elSummary.appendChild(elButton);
                    elSummary.appendChild(txSpace);
                  }
                  
                  const elPList = document.createElement("p");
                  const elList = document.createElement("ul");
                  for (toCont of encoding.containers.slice(1)) {
                    const elItem = document.createElement("li");
                    const txSpace  = document.createTextNode(" ");
                    const txCont  = document.createTextNode(toCont.name);
                    elItem.appendChild(txCont);
                    elItem.appendChild(txSpace);
                    for (toExt of toCont.extensions) {
                      const txSpace  = document.createTextNode(" ");
                      const elKboard = document.createElement("kbd");
                      const elButton = document.createElement("button");
                      const txButton = document.createTextNode(toExt);
                      elButton.setAttribute("value", encoding.abbr + "/" + toExt);
                      elButton.setAttribute("name", "submit");
                      elKboard.appendChild(txButton);
                      elButton.appendChild(elKboard);
                      elItem.appendChild(elButton);
                      elItem.appendChild(txSpace);
                    }
                    elList.appendChild(elItem);
                  }
                  
                  elPList.appendChild(elList);
                  elDetails.appendChild(elPList);
                  
                  const elDesc = document.createElement("p");
                  const elUrl  = document.createElement("a");
                  elUrl.setAttribute("href", encoding.url);
                  const txUrl  = document.createTextNode("More information about the codec ↣");
                  elDesc.appendChild(elUrl);
                  elUrl.appendChild(txUrl);
                  elDetails.appendChild(elDesc);
                  const elHr = document.createElement("hr");
                  elOptions.appendChild(elHr);                  
                }
                document.getElementById("options").style.display = "block";
                switch (optionsPath) {
                  case "json/picture.json":
                    document.getElementById("picfxs").style.display = "block";
                    document.getElementById("audfxs").style.display = "none";
                    break;
                  case "json/audio.json":
                    document.getElementById("picfxs").style.display = "none";
                    document.getElementById("audfxs").style.display = "block";
                    break;
                }
              });
          }
        });
    </script>
</body>

</html>
