<?php

$fromExt = strtolower(pathinfo($_FILES["file"]["name"])['extension']);
$toMIME  = $_POST["submit"];
$toExt   = "";
$jobId   = bin2hex(random_bytes(16));

chdir('/var/www/uploads/');
mkdir($jobId);
chdir($jobId);
move_uploaded_file($_FILES["file"]["tmp_name"], "upload.$fromExt");

$filter = array();
$afilter = array();

if (isset($_POST["blur"])) {
  array_push($filter,"gblur");
}
if (isset($_POST["pixelize"])) {
  array_push($filter,"pixelize");
}
if (isset($_POST["vignette"])) {
  array_push($filter,"vignette");
}
if (isset($_POST["tremolo"])) {
  array_push($afilter,"tremolo");
}
if (isset($_POST["vibrato"])) {
  array_push($afilter,"vibrato");
}
if (isset($_POST["speechnorm"])) {
  array_push($afilter,"speechnorm");
}
if (isset($_POST["loudnorm"])) {
  array_push($afilter,"loudnorm");
}
if (isset($_POST["extrastereo"])) {
  array_push($afilter,"extrastereo");
}
if (isset($_POST["asubboost"])) {
  array_push($afilter,"asubboost");
}
if (isset($_POST["dialoguenhance"])) {
  array_push($afilter,"dialoguenhance");
}
if (isset($_POST["earwax"])) {
  array_push($afilter,"earwax");
}
if (isset($_POST["bs2b"])) {
  array_push($afilter,"bs2b");
}
if (isset($_POST["chorus"])) {
  array_push($afilter,"aecho=0.8:0.9:1000|1800:0.3|0.25");
}
if (isset($_POST["flanger"])) {
  array_push($afilter,"flanger");
}
if (isset($_POST["aphaser"])) {
  array_push($afilter,"aphaser");
}
if (isset($_POST["crystalizer"])) {
  array_push($afilter,"crystalizer");
}
if (isset($_POST["anlmdn"])) {
  array_push($afilter,"anlmdn");
}

switch($_POST["transforms"]) {
  case "hflip":
    array_push($filter, "hflip");
    break;
  case "vflip":
    array_push($filter, "vflip");
    break;
  case "clkrot":
  array_push($filter, "rotate=PI/2");
    break;
  case "aclkrot":
    array_push($filter, "rotate=-PI/2");
    break;
  case "reverse":
    array_push($filter, "rotate=PI");
    break;
}

switch($_POST["colorize"]) {
  case "bw":
    array_push($filter,"colorchannelmixer=.3:.4:.3:0:.3:.4:.3:0:.3:.4:.3");
    break;
  case "sepia":
    array_push($filter,"colorchannelmixer=.393:.769:.189:0:.349:.686:.168:0:.272:.534:.131");
    break;
}

switch($_POST["echo"]) {
  case "two":
    array_push($afilter,"aecho=0.8:0.88:60:0.4");
    break;
  case "robot":
    array_push($afilter,"aecho=0.8:0.88:6:0.4");
    break;
  case "mountains":
    array_push($afilter,"aecho=0.8:0.9:1000:0.3");
    break;
  case "more":
    array_push($afilter,"aecho=0.8:0.9:1000|1800:0.3|0.25");
    break;
}

$filter_str = implode(',',$filter);
$filter_str = empty($filter_str) ? "" : "-vf '$filter_str'";

$afilter_str = implode(',',$afilter);
$afilter_str = empty($afilter_str) ? "" : "-af '$afilter_str'";

switch($toMIME) {
  case "FLAC/.flac":
    $toExt = "flac";
    exec("ffmpeg -y -i upload.$fromExt -acodec flac $afilter_str output.$toExt");
    break;
  case "FLAC/.ogg":
    $toExt = "ogg";
    exec("ffmpeg -y -i upload.$fromExt -acodec flac $afilter_str output.$toExt");
    break;
  case "FLAC/.oga":
    $toExt = "oga";
    exec("ffmpeg -y -i upload.$fromExt -acodec flac $afilter_str output.$toExt");
    break;
  case "FLAC/.mka":
    $toExt = "mka";
    exec("ffmpeg -y -i upload.$fromExt -acodec flac $afilter_str output.$toExt");
    break;
    
  case "ALAC/.caf":
    $toExt = "caf";
    exec("ffmpeg -y -i upload.$fromExt -acodec alac $afilter_str output.$toExt");
    break;
    
  case "WavPack/.wv":
    $toExt = "wv";
    exec("ffmpeg -y -i upload.$fromExt -acodec wavpack $afilter_str output.$toExt");
    break;
  case "WavPack/.mka":
    $toExt = "mka";
    exec("ffmpeg -y -i upload.$fromExt -acodec wavpack $afilter_str output.$toExt");
    break;
    
  case "Vorbis/.ogg":
    $toExt = "ogg";
    exec("ffmpeg -y -i upload.$fromExt -acodec vorbis $afilter_str -strict -2 output.$toExt");
    break;
  case "Vorbis/.oga":
    $toExt = "oga";
    exec("ffmpeg -y -i upload.$fromExt -acodec vorbis $afilter_str -strict -2 output.$toExt");
    break;
  case "Vorbis/.mka":
    $toExt = "mka";
    exec("ffmpeg -y -i upload.$fromExt -acodec vorbis $afilter_str -strict -2 output.$toExt");
    break;
  case "Vorbis/.webm":
    $toExt = "webm";
    exec("ffmpeg -y -i upload.$fromExt -acodec vorbis $afilter_str -strict -2 output.$toExt");
    break;
    
  case "Speex/.spx":
    $toExt = "spx";
    exec("ffmpeg -y -i upload.$fromExt -acodec speex $afilter_str output.$toExt");
    break;
  case "Speex/.ogg":
    $toExt = "ogg";
    exec("ffmpeg -y -i upload.$fromExt -acodec speex $afilter_str output.$toExt");
    break;
  case "Speex/.oga":
    $toExt = "oga";
    exec("ffmpeg -y -i upload.$fromExt -acodec speex $afilter_str output.$toExt");
    break;
    
  case "MP1/.mp1":
    $toExt = "mp1";
    exec("ffmpeg -y -i upload.$fromExt -acodec mp1 $afilter_str output.$toExt");
    break;
    
  case "MP2/.mp2":
    $toExt = "mp2";
    exec("ffmpeg -y -i upload.$fromExt -acodec mp2 $afilter_str output.$toExt");
    break;
    
  case "MP3/.mp3":
    $toExt = "mp3";
    exec("ffmpeg -y -i upload.$fromExt -acodec mp3 $afilter_str output.$toExt");
    break;
    
  case "TTA/.tta":
    $toExt = "tta";
    exec("ffmpeg -y -i upload.$fromExt -acodec tta $afilter_str output.$toExt");
    break;
    
  case "Opus/.opus":
    $toExt = "opus";
    exec("ffmpeg -y -i upload.$fromExt -acodec opus $afilter_str -strict -2 output.$toExt");
    break;
  case "Opus/.ogg":
    $toExt = "ogg";
    exec("ffmpeg -y -i upload.$fromExt -acodec opus $afilter_str -strict -2 output.$toExt");
    break;
  case "Opus/.oga":
    $toExt = "oga";
    exec("ffmpeg -y -i upload.$fromExt -acodec opus $afilter_str -strict -2 output.$toExt");
    break;
  case "Opus/.mka":
    $toExt = "mka";
    exec("ffmpeg -y -i upload.$fromExt -acodec opus $afilter_str -strict -2 output.$toExt");
    break;
  case "Opus/.webm":
    $toExt = "webm";
    exec("ffmpeg -y -i upload.$fromExt -acodec opus $afilter_str -strict -2 output.$toExt");
    break;
  case "Opus/.ts":
    $toExt = "ts";
    exec("ffmpeg -y -i upload.$fromExt -acodec opus $afilter_str -strict -2 output.$toExt");
    break;

  case "JPEG/.jpg":
    $toExt = "jpg";
    exec("ffmpeg -y -i upload.$fromExt -vcodec mjpeg $filter_str output.$toExt");
    break;
  case "JPEG/.jpeg":
    $toExt = "jpeg";
    exec("ffmpeg -y -i upload.$fromExt -vcodec mjpeg $filter_str output.$toExt");
    break;
    
  case "PNG/.png":
    $toExt = "png";
    exec("ffmpeg -y -i upload.$fromExt -vcodec png $filter_str output.$toExt");
    break;
    
  case "QOI/.qoi":
    $toExt = "qoi";
    exec("ffmpeg -y -i upload.$fromExt -vcodec qoi $filter_str output.$toExt");
    break;
    
  case "OpenEXR/.exr":
    $toExt = "exr";
    exec("ffmpeg -y -i upload.$fromExt -vcodec exr $filter_str output.$toExt");
    break;
    
  case "WebP/.webp":
    $toExt = "webp";
    exec("ffmpeg -y -i upload.$fromExt -vcodec webp $filter_str output.$toExt");
    break;
    
  case "JPEG XL/.jxl":
    $toExt = "jxl";
    exec("ffmpeg -y -i upload.$fromExt -vcodec jpegxl $filter_str output.$toExt");
    break;
    
  case "GIF/.gif":
    $toExt = "gif";
    exec("ffmpeg -y -i upload.$fromExt -vcodec gif $filter_str output.$toExt");
    break;
    
  case "JPEG 2000/.jp2":
    $toExt = "jp2";
    exec("ffmpeg -y -i upload.$fromExt -vcodec jpeg2000 $filter_str output.$toExt");
    break;
    
  case "JPEG 2000/.j2k":
    $toExt = "j2k";
    exec("ffmpeg -y -i upload.$fromExt -vcodec jpeg2000 $filter_str output.$toExt");
    break;
    
  case "JPEG 2000/.j2c":
    $toExt = "j2c";
    exec("ffmpeg -y -i upload.$fromExt -vcodec jpeg2000 $filter_str output.$toExt");
    break;
    
  case "AVIF/.avif":
    $toExt = "avif";
    exec("ffmpeg -y -i upload.$fromExt -vcodec av1 $filter_str output.$toExt");
    break;
}

header("Cache-Control: public");
header("Content-D6escription: File Transfer");
header("Content-Disposition: attachment; filename=output.$toExt");
header("Content-Transfer-Encoding: binary");

readfile("/var/www/uploads/$jobId/output.$toExt");

chdir('/var/www/uploads/');
exec("rm -r $jobId");

?>

